# Урок

:project Programming

## Списки ##

:overlay

:position 30,30,40,40

:navigate projects.code.console

### Списки

В любом языке программирования полезно иметь возможность собирать информацию в списках. Списки являются модифицируемыми (вы можете добавлять элементы в список и удалять их). В уроке по циклам будет рассказано, как выполнить действие для всех элементов списка.

## Определение списка

:navigate projects.code.console

:position 55,30,40,40

### Создание списка

В *microScript* список определяется следующим образом:

```
prime_numbers = [1, 3, 5, 7, 11, 13, 17]
animals = [ "Кот", "Собака", "Кролик" ]
```

Обратите внимание, что квадратные скобки используются для обозначения границ списка, а запятые - для разделения элементов в списке. Элементами списка могут быть любые значения *microScript*: числа, строки, функции, списки (!), объекты.

## Пустой список

:navigate projects.code.console

:position 55,30,40,40

### Пустой список

Пустой список определяется следующим образом:

```
list = []
```

## Добавить элемент

:navigate projects.code.console

:position 55,30,40,40

### Добавить элемент


Вы можете добавлять элементы с помощью функции "push".

```
list.push("элемент 1")
```

Функция "push" добавляет элемент в конец списка.

## Вставить элемент

:navigate projects.code.console

:position 55,30,40,40

### Вставить элемент

Вы можете вставить элемент в начало списка с помощью функции-члена "insert".

```
list.insert("элемент 2")
```

## Длина списка

:navigate projects.code.console

:position 55,30,40,40

### Длина списка

Длина списка (количество элементов) может быть найдена с помощью поля ``length``:

```
print( "Длина списка составляет " + list.length )
```

## Доступ к элементам списка

:navigate projects.code.console

:position 55,30,40,40

### Доступ к элементам списка

Элементы в списке индексируются, начиная с 0. Вы можете получить доступ к каждому элементу списка, используя их индексы:

```
list[0]
list[1]
```

## Изменить элемент

:navigate projects.code.console

:position 55,30,40,40

### Редактирование элемента

Вы можете изменить элемент в списке, обратившись к нему с помощью его индекса:

```
list[0] = "другой элемент"
```

Если элемент еще не существует, он создается:

```
list[2] = "новый элемент"
```

## Узнать индекс элемента

:navigate projects.code.console

:position 55,30,40,40

### Индекс элемента

Индекс элемента, т.е. его местоположение в списке, можно найти с помощью функции "indexOf":

```
list.indexOf("новый элемент")
```

## Удалить элемент

:navigate projects.code.console

:position 55,30,40,40

### Удалить элемент

Вы можете удалить элемент из списка, если знаете его индекс:

```
list.remove(1)
```

(удаляет элемент с индексом 1, который на самом деле является вторым элементом!)

## Списки

:navigate projects.code.console

:position 55,30,40,40

### Списки

Списки - это очень мощный инструмент! Позже в этом курсе вы увидите, как они могут работать вместе с циклами.
Давайте перейдем к следующему уроку.